#include <stdio.h>
#include <string>
#include <vector>

#define NMax 1005
#define MMax 100005

using namespace std;

int N, M;
char s[NMax];
int L[NMax];
vector<int> c[NMax];
string stamp[NMax];

int main() {
	freopen("birocratie.in", "rt", stdin);
	freopen("birocratie.out", "wt", stdout);

	scanf("%d %d\n", &N, &M);

	for (int i = 1; i <= N; i++) {
		scanf("%c %d", &s[i], &L[i]);
		for (int j = 0; j < L[i]; j++) {
			int x;
			scanf("%d", &x);
			c[i].push_back(x);
		}
		scanf("\n");
	}

	for (int i = N; i >= 1; i--) {
		if (L[i] == 0) {
			stamp[i] = s[i];
		} else {
			stamp[i] = s[i];
			for (int j = 0; j < c[i].size(); j++) {
				stamp[i] += stamp[c[i][j]] + s[i];
			}
		}
	}

	int q, k;
	for (int i = 1; i <= M; i++) {
		scanf("%d %d", &q, &k);
		printf("%c\n", stamp[q][k - 1]);
	}

	fclose(stdout);
	return 0;
}
